<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/rootDoc.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/rootdoc.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/rootDoc.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** This class holds the information from one run of PHPDoctor. Particularly
<a name="line22"></a> * the packages, classes and options specified by the user. It is the root
<a name="line23"></a> * of the parsed tokens and is passed to the doclet to be formatted into
<a name="line24"></a> * output.
<a name="line25"></a> *
<a name="line26"></a> * @package PHPDoctor
<a name="line27"></a> */
<a name="line28"></a>class RootDoc extends Doc
<a name="line29"></a>{
<a name="line30"></a>
<a name="line31"></a>	/** Reference to the PHPDoctor application object.
<a name="line32"></a>	 *
<a name="line33"></a>	 * @var phpdoctor
<a name="line34"></a>	 */
<a name="line35"></a>	var $_phpdoctor = NULL;
<a name="line36"></a>
<a name="line37"></a>	/** The parsed packages.
<a name="line38"></a>	 *
<a name="line39"></a>	 * @var packageDoc[]
<a name="line40"></a>	 */
<a name="line41"></a>	var $_packages = array();
<a name="line42"></a>	
<a name="line43"></a>	/** The parsed contents of the source files
<a name="line44"></a>	 *
<a name="line45"></a>	 * @var str[]
<a name="line46"></a>	 */
<a name="line47"></a>	var $_sources = array();
<a name="line48"></a>
<a name="line49"></a>	/** Constructor
<a name="line50"></a>	 *
<a name="line51"></a>	 * @param PHPDoctor phpdoctor Application object
<a name="line52"></a>	 */
<a name="line53"></a>	function rootDoc(&$phpdoctor)
<a name="line54"></a>    {
<a name="line55"></a>	
<a name="line56"></a>		// set a reference to application object
<a name="line57"></a>		$this->_phpdoctor =& $phpdoctor;
<a name="line58"></a>		
<a name="line59"></a>		$overview = $phpdoctor->getOption('overview');
<a name="line60"></a>		// parse overview file
<a name="line61"></a>		if (isset($overview)) {
<a name="line62"></a>			if (is_file($overview)) {
<a name="line63"></a>				$phpdoctor->message('Reading overview file "'.$overview.'".');
<a name="line64"></a>				if ($html = $this->getHTMLContents($overview)) {
<a name="line65"></a>					$this->_data = $phpdoctor->processDocComment('/** '.$html.' */', $this);
<a name="line66"></a>					$this->mergeData();
<a name="line67"></a>				}
<a name="line68"></a>			} else {
<a name="line69"></a>				$phpdoctor->warning('Could not find overview file "'.$overview.'".');
<a name="line70"></a>			}
<a name="line71"></a>		}
<a name="line72"></a>	
<a name="line73"></a>	}
<a name="line74"></a>	
<a name="line75"></a>	/** Add a package to this root.
<a name="line76"></a>	 *
<a name="line77"></a>	 * @param PackageDoc package
<a name="line78"></a>	 */
<a name="line79"></a>	function addPackage(&$package)
<a name="line80"></a>    {
<a name="line81"></a>		$this->_packages[$package->name()] =& $package;
<a name="line82"></a>	}
<a name="line83"></a>	
<a name="line84"></a>	/** Add a source file to this root.
<a name="line85"></a>	 *
<a name="line86"></a>	 * @param str filename
<a name="line87"></a>	 * @param str source
<a name="line88"></a>	 * @param str[] fileData
<a name="line89"></a>	 */
<a name="line90"></a>	function addSource($filename, $source, $fileData)
<a name="line91"></a>    {
<a name="line92"></a>		$this->_sources[substr($filename, strlen($this->_phpdoctor->sourcePath()) + 1)] = array(
<a name="line93"></a>		    $source, $fileData
<a name="line94"></a>        );
<a name="line95"></a>	}
<a name="line96"></a>	
<a name="line97"></a>	/** Return a reference to the PHPDoctor application object.
<a name="line98"></a>	 *
<a name="line99"></a>	 * @return PHPDoctor.
<a name="line100"></a>	 */
<a name="line101"></a>	function &phpdoctor()
<a name="line102"></a>    {
<a name="line103"></a>		return $this->_phpdoctor;
<a name="line104"></a>	}
<a name="line105"></a>
<a name="line106"></a>	/** Return a reference to the set options.
<a name="line107"></a>	 *
<a name="line108"></a>	 * @return str[] An array of strings.
<a name="line109"></a>	 */
<a name="line110"></a>	function &options()
<a name="line111"></a>    {
<a name="line112"></a>		return $this->_phpdoctor->options();
<a name="line113"></a>	}
<a name="line114"></a>
<a name="line115"></a>	/** Return a reference to the packages to be documented.
<a name="line116"></a>	 *
<a name="line117"></a>	 * @return PackageDoc[]
<a name="line118"></a>	 */
<a name="line119"></a>	function &packages()
<a name="line120"></a>    {
<a name="line121"></a>		return $this->_packages;
<a name="line122"></a>	}
<a name="line123"></a>	
<a name="line124"></a>	/** Return a reference to the source files to be documented.
<a name="line125"></a>	 *
<a name="line126"></a>	 * @return str[]
<a name="line127"></a>	 */
<a name="line128"></a>	function &sources()
<a name="line129"></a>	{
<a name="line130"></a>	    return $this->_sources;
<a name="line131"></a>	}
<a name="line132"></a>
<a name="line133"></a>	/** Return a reference to the classes and interfaces to be documented.
<a name="line134"></a>	 *
<a name="line135"></a>	 * @return ClassDoc[]
<a name="line136"></a>	 */
<a name="line137"></a>	function &classes()
<a name="line138"></a>    {
<a name="line139"></a>		$classes = array();
<a name="line140"></a>		$packages = $this->packages(); // not by reference so as not to move the internal array pointer
<a name="line141"></a>		foreach ($packages as $name => $package) {
<a name="line142"></a>			$packageClasses = $this->_packages[$name]->allClasses(); // not by reference so as not to move the internal array pointer
<a name="line143"></a>			if ($packageClasses) {
<a name="line144"></a>				foreach ($packageClasses as $key => $pack) {
<a name="line145"></a>					$classes[$key.'.'.$name] =& $packageClasses[$key];
<a name="line146"></a>				}
<a name="line147"></a>			}
<a name="line148"></a>		}
<a name="line149"></a>		ksort($classes);
<a name="line150"></a>		return $classes;
<a name="line151"></a>	}
<a name="line152"></a>
<a name="line153"></a>	/** Return a reference to the functions to be documented.
<a name="line154"></a>	 *
<a name="line155"></a>	 * @return MethodDoc[]
<a name="line156"></a>	 */
<a name="line157"></a>	function &functions()
<a name="line158"></a>    {
<a name="line159"></a>		$functions = array();
<a name="line160"></a>		$packages = $this->packages(); // not by reference so as not to move the internal array pointer
<a name="line161"></a>		foreach ($packages as $name => $package) {
<a name="line162"></a>			$packageFunctions = $this->_packages[$name]->functions(); // not by reference so as not to move the internal array pointer
<a name="line163"></a>			if ($packageFunctions) {
<a name="line164"></a>				foreach ($packageFunctions as $key => $pack) {
<a name="line165"></a>					$functions[$name.'.'.$key] =& $packageFunctions[$key];
<a name="line166"></a>				}
<a name="line167"></a>			}
<a name="line168"></a>		}
<a name="line169"></a>		return $functions;
<a name="line170"></a>	}
<a name="line171"></a>
<a name="line172"></a>	/** Return a reference to the globals to be documented.
<a name="line173"></a>	 *
<a name="line174"></a>	 * @return FieldDoc[]
<a name="line175"></a>	 */
<a name="line176"></a>	function &globals()
<a name="line177"></a>    {
<a name="line178"></a>		$globals = array();
<a name="line179"></a>		$packages = $this->packages(); // not by reference so as not to move the internal array pointer
<a name="line180"></a>		foreach ($packages as $name => $package) {
<a name="line181"></a>			$packageGlobals = $this->_packages[$name]->globals(); // not by reference so as not to move the internal array pointer
<a name="line182"></a>			if ($packageGlobals) {
<a name="line183"></a>				foreach ($packageGlobals as $key => $pack) {
<a name="line184"></a>					$globals[$name.'.'.$key] =& $packageGlobals[$key];
<a name="line185"></a>				}
<a name="line186"></a>			}
<a name="line187"></a>		}
<a name="line188"></a>		ksort($globals);
<a name="line189"></a>		return $globals;
<a name="line190"></a>	}
<a name="line191"></a>	
<a name="line192"></a>	/** Return a reference to a packageDoc for the specified package name. If a
<a name="line193"></a>	 * package of the requested name does not exist, this method will create the
<a name="line194"></a>	 * package object, add it to the root and return it.
<a name="line195"></a>	 *
<a name="line196"></a>	 * @param str name Package name
<a name="line197"></a>	 * @param bool create Create package if it does not exist
<a name="line198"></a>	 * @return PackageDoc
<a name="line199"></a>	 */
<a name="line200"></a>	function &packageNamed($name, $create = FALSE)
<a name="line201"></a>    {
<a name="line202"></a>        $return = NULL;
<a name="line203"></a>		if (isset($this->_packages[$name])) {
<a name="line204"></a>			$return =& $this->_packages[$name];
<a name="line205"></a>		} elseif ($create) {
<a name="line206"></a>			$newPackage =& new packageDoc($name, $this);
<a name="line207"></a>			$this->addPackage($newPackage);
<a name="line208"></a>			$return =& $newPackage;
<a name="line209"></a>		}
<a name="line210"></a>        return $return;
<a name="line211"></a>	}
<a name="line212"></a>
<a name="line213"></a>	/** Return a reference to a classDoc for the specified class/interface name
<a name="line214"></a>	 *
<a name="line215"></a>	 * @param str name Class name
<a name="line216"></a>	 * @return ClassDoc
<a name="line217"></a>	 */
<a name="line218"></a>	function &classNamed($name)
<a name="line219"></a>    {
<a name="line220"></a>        $class = NULL;
<a name="line221"></a>        $pos = strrpos($name, '\\');
<a name="line222"></a>        if ($pos != FALSE) {
<a name="line223"></a>            $package = substr($name, 0, $pos);
<a name="line224"></a>            $name = substr($name, $pos + 1);
<a name="line225"></a>		}
<a name="line226"></a>		if (isset($package) && isset($this->_packages[$package])) {
<a name="line227"></a>		    $class =& $this->_packages[$package]->findClass($name);
<a name="line228"></a>		} else {
<a name="line229"></a>            $packages = $this->_packages; // we do this copy so as not to upset the internal pointer of the array outside this scope
<a name="line230"></a>            foreach($packages as $packageName => $package) {
<a name="line231"></a>                $class =& $package->findClass($name);
<a name="line232"></a>                if ($class != NULL) break;
<a name="line233"></a>            }
<a name="line234"></a>        }
<a name="line235"></a>		return $class;
<a name="line236"></a>	}
<a name="line237"></a>
<a name="line238"></a>}
<a name="line239"></a>
<a name="line240"></a>?>
<a name="line241"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/rootdoc.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>